	.dbfile C:\iccv7arm\MI2CB2~1\MicroBolt_I2C_Master.c
	AREA	"Cidata", DATA
_I2cSlaveAddress:
	DCB 0
	.dbsym s I2cSlaveAddress _I2cSlaveAddress c
_I2cBufferIndex:
	DCB 0
	.dbsym s I2cBufferIndex _I2cBufferIndex c
_I2cPacketDataSize:
	DCB 0
	.dbsym s I2cPacketDataSize _I2cPacketDataSize c
_I2cPacketType:
	DCB 0
	.dbsym s I2cPacketType _I2cPacketType c
_I2cPacketInProgress:
	DCB 0
	.dbsym s I2cPacketInProgress _I2cPacketInProgress c
	AREA	"C$$code", CODE, READONLY
	EXPORT _main
	.dbfunc e main _main fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_main:
	stmfd R13!,{R14}
	.dbline -1
	.dbline 44
; /*
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; | File Name			  : MicroBolt_I2C_Master.c																					
; | Author			    : Micromint, Inc.						
; | Copyright       : Copyright  2005, Micromint, Inc.																	
; | Creation Date		: 12/30/05																							
; | Version			    : 1.00																																												
; | Spaces per tab	:	2																									
; | Description		  : Main C file																																									 
; | Revision			  :	Initial																																																						
; |------------------------------------------------------------------------------------------
; |------------------------------------------------------------------------------------------
; */
; 
; /*
; |----------------------------------------------------
; |     Includes
; |----------------------------------------------------
; */
; 
; #include <ARM/philips/lpc210x.h>
; #include <arm_macros.h>
; #include "MicroBolt_I2C_Master.h"
; 
; static unsigned char I2cSlaveAddress = 0;       // I2C slave address
; static unsigned char I2cBuffer[20];             // I2C application buffer
; static unsigned char I2cBufferIndex = 0;        // Index for I2C buffer
; static unsigned char I2cPacketDataSize = 0;     // Number of data bytes for an I2C packet
; static unsigned char I2cPacketType = 0;         // Read or Write packet type
; static unsigned char I2cPacketInProgress = 0;	  // I2C Packet in progress flag			
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   main
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Main function for system
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void main(void)
;   {
	.dbline 46
; 
;   __DISABLE_INTERRUPT();                        // Disable all interrupts
	mrs R12,cpsr
	orr R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 53
; 
; /*
; |-------------------------
; | Config MAM 
; |-------------------------
; */
;   MAM_CR = 0x00;                                // Turn MAM off (default)
	mov R4,#0
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 54
;   MAM_TIM = 0x04;                               // Set flash timing to 4 clock cycles
	mov R4,#4
	ldr R5,LIT_main+4
	str R4,[R5,#0]
	.dbline 56
; 
;   MAM_CR = 0x02;                                // Fully enable the Memory Accleration Module
	mov R4,#2
	ldr R5,LIT_main+0
	str R4,[R5,#0]
	.dbline 63
; 
; /*
; |-------------------------
; | Config PLL and CCLK 
; |-------------------------
; */
;   SCB_PLLCFG |= 0x23;				 	   		            // Set to 59 MHz (0x03 is multiply value of 4)
	ldr R4,LIT_main+8
	ldr R5,[R4,#0]
	orr R5,R5,#35
	str R5,[R4,#0]
	.dbline 64
;   SCB_PLLCON |= 0x01;                           // Enable the PLL 
	ldr R4,LIT_main+12
	ldr R5,[R4,#0]
	orr R5,R5,#1
	str R5,[R4,#0]
	.dbline 65
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R4,#170
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 66
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R4,#85
	ldr R5,LIT_main+16
	str R4,[R5,#0]
	.dbline 73
; 
; /*
; |-------------------------
; | Config PCLK 
; |-------------------------
; */
;   SCB_VPBDIV = 0;                               // Peripheral clock is 1/4th Processor clock which equals 14.7456 MHz
	mov R4,#0
	ldr R5,LIT_main+20
	str R4,[R5,#0]
	.dbline 80
; 
; /*
; |-------------------------
; | Configure VIC 
; |-------------------------
; */
;   VICVectAddr0 = (unsigned)pll_isr;             // Assign the PLL lock ISR vector address
	ldr R4,LIT_main+24
	ldr R5,LIT_main+28
	str R4,[R5,#0]
	.dbline 81
;   VICVectCntl0 = INTERRUPT_CHANNEL_FOR_PLL;     // Assign the VIC address to the actual interrupt
	mov R4,#44
	ldr R5,LIT_main+32
	str R4,[R5,#0]
	.dbline 82
;   VICIntEnable = INTERRUPT_ENABLE_FOR_PLL;      // Enable the interrupt  
	mov R4,#4096
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 84
; 
; 	VICVectAddr1 = (unsigned)I2c_ISR;							// Assign the I2C ISR vector address 
	ldr R4,LIT_main+40
	ldr R5,LIT_main+44
	str R4,[R5,#0]
	.dbline 85
;   VICVectCntl1 = INTERRUPT_CHANNEL_FOR_I2C;     // Assign the VIC address to the actual interrupt
	mov R4,#41
	ldr R5,LIT_main+48
	str R4,[R5,#0]
	.dbline 86
;   VICIntEnable = INTERRUPT_ENABLE_FOR_I2C;      // Enable the interrupt 
	mov R4,#512
	ldr R5,LIT_main+36
	str R4,[R5,#0]
	.dbline 88
; 
;   __ENABLE_INTERRUPT();                         // Enable all interrupts
	mrs R12,cpsr
	bic R12,R12,#0x80
	msr cpsr_c,R12
	
	.dbline 95
; 
; /*
; |-------------------------
; | Config GPIO 
; |-------------------------
; */
;   PCB_PINSEL0=0x00000050;                       // Setup with ICCARM App builder - MicroBolt_I2C_Master.bcf (I2C)   
	mov R4,#80
	ldr R5,LIT_main+52
	str R4,[R5,#0]
	.dbline 96
;   PCB_PINSEL1=0x55400000;                       //                                   (Secondary JTAG pins) 
	ldr R4,LIT_main+56
	ldr R5,LIT_main+60
	str R4,[R5,#0]
	.dbline 98
; 
;   GPIO_IODIR |= MICROBOLT_LED;                  // Setup MicroBolt LED as output
	ldr R4,LIT_main+64
	ldr R5,[R4,#0]
	orr R5,R5,#4194304
	str R5,[R4,#0]
	.dbline 99
;   GPIO_IODIR |= P0_9;                           // P0_9 for debug
	ldr R4,LIT_main+64
	ldr R5,[R4,#0]
	orr R5,R5,#512
	str R5,[R4,#0]
	.dbline 101
; 
;   GPIO_IOCLR=0xffffffff;                        // Clear all pins to start with
	mvn R4,#0
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 108
; 
; /*
; |-------------------------
; | Config I2C Master
; |-------------------------
; */
;   I2C_I2SCLH = 37;                              // I2C clock is 200 KHz (14.7456 MHz/(SCLH + SCLL))
	mov R4,#37
	ldr R5,LIT_main+72
	str R4,[R5,#0]
	.dbline 109
;   I2C_I2SCLL = 37;
	mov R4,#37
	ldr R5,LIT_main+76
	str R4,[R5,#0]
	.dbline 111
; 
;   I2C_I2CONSET = I2C_ENABLE_BIT;                // Enable the I2C channel
	mov R4,#64
	ldr R5,LIT_main+80
	str R4,[R5,#0]
	.dbline 120
; 
; /*
; |---------------------------------
; | Config I2C PCA9551 Slave device
; |---------------------------------
; */                                              // Initialize I2C buffers with desired data for PCA9551 slave
;                                                 // The below configuration toggles the PCA9551 outputs 3 times a second
;                                                 // For this application, only LED-1 and LED-7 are wired up
;   I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9551;     // Address the PCA9551
	mov R4,#194
	ldr R5,LIT_main+84
	strb R4,[R5,#0]
	.dbline 121
;   I2cPacketDataSize = 5;                        // How many bytes from the I2c buffer to send
	mov R4,#5
	ldr R5,LIT_main+88
	strb R4,[R5,#0]
	.dbline 122
;   I2cBuffer[0] = 0x13;                          // Control register sets starting address and autoincrement to on 
	mov R4,#19
	ldr R5,LIT_main+92
	strb R4,[R5,#0]
	.dbline 123
;   I2cBuffer[1] = 0x10;                          // Prescaler 1 value 
	mov R4,#16
	ldr R5,LIT_main+96
	strb R4,[R5,#0]
	.dbline 124
;   I2cBuffer[2] = 0x80;                          // PWM-1 value
	mov R4,#128
	ldr R5,LIT_main+100
	strb R4,[R5,#0]
	.dbline 125
;   I2cBuffer[3] = 0xFF;                          // LED 0 to 3 assigned to PWM-1
	mov R4,#255
	ldr R5,LIT_main+104
	strb R4,[R5,#0]
	.dbline 126
;   I2cBuffer[4] = 0xFF;                          // LED 4 to 7 assigned to PWM-1
	mov R4,#255
	ldr R5,LIT_main+108
	strb R4,[R5,#0]
	.dbline 127
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L6:
	.dbline 128
L7:
	.dbline 128
;   while(I2cPacketInProgress == TRUE);           // Wait here for I2C packet to complete 
	ldr R4,LIT_main+112
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L6
	.dbline 135
; 
; /*
; |-----------------------------------------------------
; | Send a new control byte to PCA9551 I2C Slave device
; |-----------------------------------------------------
; */   
;   I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9551;     // Address the PCA9551
	mov R4,#194
	ldr R5,LIT_main+84
	strb R4,[R5,#0]
	.dbline 136
;   I2cPacketDataSize = 1;                        // How many bytes from the I2c buffer to send
	mov R4,#1
	ldr R5,LIT_main+88
	strb R4,[R5,#0]
	.dbline 137
;   I2cBuffer[0] = 0x00;                          // Control register set to 0, turn off autoincrement 
	mov R4,#0
	ldr R5,LIT_main+92
	strb R4,[R5,#0]
	.dbline 138
;   I2cStart(I2C_WRITE);                          // Send out an I2C Start condition for a Write packet
	mov R0,#0
	bl _I2cStart
L9:
	.dbline 139
L10:
	.dbline 139
;   while(I2cPacketInProgress == TRUE);           // Wait here for previous I2C packet to complete 
	ldr R4,LIT_main+112
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L9
	b L13
L12:
	.dbline 148
; 
; /*
; |----------------------------------------------------
; |     Start of application
; |----------------------------------------------------
; */
; 
;   while(1)                                      // Do this forever
;     {
	.dbline 154
; /*
; |------------------------------------------------
; | Read PCA9551 I2C Slave device's input register
; |------------------------------------------------
; */  
;     I2cSlaveAddress = I2C_SLAVE_ADDR_PCA9551;   // Address the PCA9551
	mov R4,#194
	ldr R5,LIT_main+84
	strb R4,[R5,#0]
	.dbline 155
;     I2cPacketDataSize = 1;                      // How many bytes from the I2c buffer to receive
	mov R4,#1
	ldr R5,LIT_main+88
	strb R4,[R5,#0]
	.dbline 156
;     I2cStart(I2C_READ);                         // Send out an I2C Start condition for a Read packet 
	mov R0,#1
	bl _I2cStart
L15:
	.dbline 157
L16:
	.dbline 157
;     while(I2cPacketInProgress == TRUE);         // Wait here for previous I2C packet to complete 
	ldr R4,LIT_main+112
	ldrb R4,[R4,#0]
	cmp R4,#1
	beq L15
	.dbline 159
; 
;     if (I2cBuffer[0] == 0x82)		                // LED-1 and LED-7 read as ON from the PCA9551 via the I2C buffer?
	ldr R4,LIT_main+92
	ldrb R4,[R4,#0]
	cmp R4,#130
	bne L18
	.dbline 160
; 		    {
	.dbline 161
;         GPIO_IOCLR = MICROBOLT_LED;							// Yes, turn off the MicroBolt LED to match LED-1 and LED-7
	mov R4,#4194304
	ldr R5,LIT_main+68
	str R4,[R5,#0]
	.dbline 162
; 				}
	b L19
L18:
	.dbline 164
; 		else
; 				{
	.dbline 165
;         GPIO_IOSET = MICROBOLT_LED;							// No, turn on the MicroBolt LED to match LED-1 and LED-7
	mov R4,#4194304
	ldr R5,LIT_main+116
	str R4,[R5,#0]
	.dbline 166
; 			  }
L19:
	.dbline 167
L13:
	.dbline 147
	b L12
X0:
	.dbline -2
L1:
	ldmfd R13!,{R15}
	.dbline 0 ; func end
LIT_main:
	DCD -534790144
	DCD -534790140
	DCD -534790012
	DCD -534790016
	DCD -534790004
	DCD -534789888
	DCD _pll_isr
	DCD -3840
	DCD -3584
	DCD -4080
	DCD _I2c_ISR
	DCD -3836
	DCD -3580
	DCD -536690688
	DCD 1430257664
	DCD -536690684
	DCD -536707064
	DCD -536707060
	DCD -536756208
	DCD -536756204
	DCD -536756224
	DCD _I2cSlaveAddress
	DCD _I2cPacketDataSize
	DCD _I2cBuffer
	DCD _I2cBuffer+1
	DCD _I2cBuffer+2
	DCD _I2cBuffer+3
	DCD _I2cBuffer+4
	DCD _I2cPacketInProgress
	DCD -536707068
	.dbend
	EXPORT _I2c_ISR
	.dbfunc e I2c_ISR _I2c_ISR fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_I2c_ISR:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R7,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 183
;     }
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2c_ISR
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   I2C interrupt and command processing
; |     Author          :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler I2c_ISR
; 
; void I2c_ISR(void)
; {
	.dbline 184
; 	switch(I2C_I2STAT)
	ldr R4,LIT_I2c_ISR+0
	ldr R7,[R4,#0]
	cmp R7,#48
	beq L31
	cmp R7,#48
	bgt L42
L41:
	cmp R7,#24
	beq L26
	cmp R7,#24
	bgt L44
L43:
	cmp R7,#8
	beq L24
	cmp R7,#8
	blt L21
L45:
	mov R4,R7
	cmp R4,#16
	beq L25
	b L21
L44:
	cmp R7,#32
	beq L30
	cmp R7,#32
	blt L21
L46:
	mov R4,R7
	cmp R4,#40
	beq L27
	b L21
L42:
	cmp R7,#72
	beq L39
	cmp R7,#72
	bgt L48
L47:
	cmp R7,#56
	beq L32
	cmp R7,#56
	blt L21
L49:
	mov R4,R7
	cmp R4,#64
	beq L33
	b L21
L48:
	cmp R7,#80
	beq L36
	cmp R7,#80
	blt L21
L50:
	mov R4,R7
	cmp R4,#88
	beq L40
	b L21
X1:
	.dbline 185
; 			{
L24:
	.dbline 190
; //****************************************************
; // I2C Master Transmit Service Routines
; //****************************************************
; 			case (0x08):																									// START condition transmitted
; 					{
	.dbline 191
; 					I2cBufferIndex = 0;																			  // Reset index counter
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 192
;           I2C_I2DAT = I2cSlaveAddress | I2cPacketType;              // Desired slave address into I2C register OR'd with Read or Write
	ldr R4,LIT_I2c_ISR+8
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+12
	ldrb R5,[R5,#0]
	orr R4,R5,R4
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 193
;       	  I2C_I2CONCLR = I2C_STOP_BIT;	                            // Clear stop bit per datasheet
	mov R4,#16
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 194
; 					break;
	b L22
L25:
	.dbline 198
; 					}
; //------------------------------------
; 			case (0x10):																									// Repeated START condition transmitted
; 					{
	.dbline 199
; 					I2cBufferIndex = 0;																			  // Reset index counter
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 200
;           I2C_I2DAT = I2cSlaveAddress | I2cPacketType;              // Desired slave address into I2C register OR'd with Read or Write
	ldr R4,LIT_I2c_ISR+8
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+12
	ldrb R5,[R5,#0]
	orr R4,R5,R4
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 201
;       	  I2C_I2CONCLR = I2C_STOP_BIT;	                            // Clear stop bit per datasheet
	mov R4,#16
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 202
; 					break;
	b L22
L26:
	.dbline 206
; 					}
; //------------------------------------
; 			case (0x18):																									// Slave address with WRITE transmitted and ACK received
; 					{
	.dbline 207
;           I2C_I2DAT = I2cBuffer[I2cBufferIndex];                    // Put data from I2c buffer into I2C register for sending 
	ldr R4,LIT_I2c_ISR+24
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	ldrb R4,[R5,+R4]
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 208
;           I2cBufferIndex++;                                         // Increment the buffer index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 209
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet        
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 210
;   				break;
	b L22
L27:
	.dbline 214
; 					}
; //------------------------------------
; 			case (0x28):																									// Data byte transmitted and ACK received
; 					{
	.dbline 215
;           I2C_I2DAT = I2cBuffer[I2cBufferIndex];                    // Put data from I2c buffer into I2C register for sending  
	ldr R4,LIT_I2c_ISR+24
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	ldrb R4,[R5,+R4]
	ldr R5,LIT_I2c_ISR+16
	str R4,[R5,#0]
	.dbline 216
;           I2cBufferIndex++;                                         // Increment the buffer index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 217
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet  
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 219
; 
;           if (I2cBufferIndex > I2cPacketDataSize)                   // All the bytes from the I2C buffer sent out?
	ldr R4,LIT_I2c_ISR+28
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	cmp R5,R4
	ble L22
	.dbline 220
;       	      {
	.dbline 221
;               I2C_I2CONCLR = I2C_START_BIT;                         // Yes, Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 222
;               I2cStop();                                            // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 223
;               }
	.dbline 224
; 					break;
	b L22
L30:
	.dbline 228
; 					}
; //------------------------------------
; 			case (0x20):																									// Slave address transmitted and NAK received
; 					{
	.dbline 229
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 230
;           I2cStop();                                                // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 231
; 					break;
	b L22
L31:
	.dbline 235
; 					}
; //------------------------------------
; 			case (0x30):																									// Data byte transmitted and NAK received
; 					{
	.dbline 236
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 237
;           I2cStop();                                                // Done sending data, send a stop condition to end packet
	bl _I2cStop
	.dbline 238
; 					break;
	b L22
L32:
	.dbline 242
; 					}
; //------------------------------------
; 			case (0x38):																									// Master lost arbitration 
; 					{                                                         // Could send another START if desirable
	.dbline 243
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 244
; 					break;
	b L22
L33:
	.dbline 252
; 					}
; //------------------------------------
; 
; //****************************************************
; // I2C Master Receive Service Routines
; //****************************************************
; 			case (0x40):																									// Slave address with READ transmitted and ACK received
; 					{
	.dbline 253
; 					if (I2cPacketDataSize <= 1)		                            // Only one byte for the packet?
	ldr R4,LIT_I2c_ISR+28
	ldrb R4,[R4,#0]
	cmp R4,#1
	bgt L34
	.dbline 254
; 					    {
	.dbline 255
; 	            I2C_I2CONCLR = I2C_AA_BIT;                            // Send a NAK, don't want any more bytes
	mov R4,#4
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 256
; 							I2cBufferIndex = 0;													          // Reset count index
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 257
; 							}
	b L35
L34:
	.dbline 259
; 					else
; 							{
	.dbline 260
; 	            I2C_I2CONSET |= I2C_AA_BIT;                           // Send an ACK
	ldr R4,LIT_I2c_ISR+32
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 261
; 						  }
L35:
	.dbline 263
; 
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet            
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 264
; 					break;
	b L22
L36:
	.dbline 268
; 					}
; //------------------------------------
; 			case (0x50):																									// Data byte received and ACK returned
; 					{                                                         
	.dbline 269
; 					I2cBuffer[I2cBufferIndex] = I2C_I2DAT;									  // Grab the I2C data and put it into the I2C buffer
	ldr R4,LIT_I2c_ISR+4
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+24
	ldr R6,LIT_I2c_ISR+16
	ldr R6,[R6,#0]
	strb R6,[R4,+R5]
	.dbline 270
;           I2cBufferIndex++;																          // Increment buffer count index
	ldr R4,LIT_I2c_ISR+4
	ldrb R5,[R4,#0]
	add R5,R5,#1
	strb R5,[R4,#0]
	.dbline 271
; 					if (I2cBufferIndex < (I2cPacketDataSize - 1))             // Still more data to come for packet?
	ldr R4,LIT_I2c_ISR+28
	ldrb R4,[R4,#0]
	sub R4,R4,#1
	ldr R5,LIT_I2c_ISR+4
	ldrb R5,[R5,#0]
	cmp R5,R4
	bge L37
	.dbline 272
; 					    {
	.dbline 273
; 	            I2C_I2CONSET |= I2C_AA_BIT;                           // Yes, Send an ACK
	ldr R4,LIT_I2c_ISR+32
	ldr R5,[R4,#0]
	orr R5,R5,#4
	str R5,[R4,#0]
	.dbline 274
; 							}
	b L38
L37:
	.dbline 276
; 					else
; 							{
	.dbline 277
; 	            I2C_I2CONCLR = I2C_AA_BIT;                            // No, Send a NAK, don't want any more bytes
	mov R4,#4
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 278
; 							I2cBufferIndex = 0;													          // Reset count index
	mov R4,#0
	ldr R5,LIT_I2c_ISR+4
	strb R4,[R5,#0]
	.dbline 279
; 						  }
L38:
	.dbline 281
; 
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 282
; 					break;
	b L22
L39:
	.dbline 286
; 					}
; //------------------------------------
; 			case (0x48):																									// Slave address with READ transmitted and NAK received
; 					{
	.dbline 287
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 288
;           I2cStop();                                                // Send a stop condition to end packet
	bl _I2cStop
	.dbline 289
; 					break;
	b L22
L40:
	.dbline 293
; 					}
; //------------------------------------
; 			case (0x58):																									// Data byte received and NAK returned
; 					{           
	.dbline 294
; 					I2cBuffer[I2cBufferIndex] = I2C_I2DAT;									  // Grab the I2C data and put it into the I2C buffer                                              
	ldr R4,LIT_I2c_ISR+4
	ldrb R4,[R4,#0]
	ldr R5,LIT_I2c_ISR+24
	ldr R6,LIT_I2c_ISR+16
	ldr R6,[R6,#0]
	strb R6,[R4,+R5]
	.dbline 295
;           I2C_I2CONCLR = I2C_START_BIT;                             // Clear start bit per datasheet  
	mov R4,#32
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 296
;           I2cStop();                                                // Send a stop condition to end packet
	bl _I2cStop
	.dbline 297
; 					break;
	b L22
L21:
	.dbline 301
; 					}
; //------------------------------------
; 			default:
; 					{
	.dbline 302
;       	  I2C_I2CONCLR = I2C_START_BIT | I2C_STOP_BIT;		          // Clear start and stop bits per datasheet 
	mov R4,#48
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 303
; 					break;
L22:
	.dbline 308
; 					}
; 			}
; //------------------------------------
; 
; 	I2C_I2CONCLR = I2C_SI_BIT;																		    // Clear I2C SI interrupt flag 
	mov R4,#8
	ldr R5,LIT_I2c_ISR+20
	str R4,[R5,#0]
	.dbline 309
; 	VICVectAddr = VIC_ACK; 																						// Acknowledge Interrupt
	mov R4,#0
	ldr R5,LIT_I2c_ISR+36
	str R4,[R5,#0]
	.dbline -2
L20:
	ldmfd R13!,{R0,R1,R2,R3,R4,R5,R6,R7,R11,R12,PC}^
	.dbline 0 ; func end
LIT_I2c_ISR:
	DCD -536756220
	DCD _I2cBufferIndex
	DCD _I2cPacketType
	DCD _I2cSlaveAddress
	DCD -536756216
	DCD -536756200
	DCD _I2cBuffer
	DCD _I2cPacketDataSize
	DCD -536756224
	DCD -4048
	.dbend
	EXPORT _I2cStart
	.dbfunc e I2cStart _I2cStart fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
; I2cReadOrWriteNot -> R4
_I2cStart:
	mov R12,R13
	stmfd R13!,{R4,R12,R14}
	mov R4,R0
	.dbline -1
	.dbline 323
; }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2cStart
; |     Inputs          :   I2cReadOrWriteNot
; |     Outputs         :   None
; |     Purpose         :   Send a start condition and setup packet type (Read or Write)
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void I2cStart(unsigned char I2cReadOrWriteNot)
;   {
	.dbline 324
;   I2cPacketInProgress = TRUE;                   // Flag for stating an I2C packet is about to happen
	mov R0,#1
	ldr R1,LIT_I2cStart+0
	strb R0,[R1,#0]
	.dbline 325
;   I2cPacketType = I2cReadOrWriteNot;            // Flag for stating what kind of packet it is; Read or Write
	ldr R0,LIT_I2cStart+4
	strb R4,[R0,#0]
	.dbline 326
; 	I2C_I2CONSET |= I2C_START_BIT;                // Set the start bit 
	ldr R0,LIT_I2cStart+8
	ldr R1,[R0,#0]
	orr R1,R1,#32
	str R1,[R0,#0]
	.dbline 328
; 
;   GPIO_IOSET = P0_9;                            // Set P0_9 for debug
	mov R0,#512
	ldr R1,LIT_I2cStart+12
	str R0,[R1,#0]
	.dbline -2
L51:
	ldmfd R13!,{R4,SP,PC}
	.dbline 0 ; func end
LIT_I2cStart:
	DCD _I2cPacketInProgress
	DCD _I2cPacketType
	DCD -536756224
	DCD -536707068
	.dbsym r I2cReadOrWriteNot 4 c
	.dbend
	EXPORT _I2cStop
	.dbfunc e I2cStop _I2cStop fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_I2cStop:
	.dbline -1
	.dbline 342
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   I2cStop
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Send a stop condition
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; void I2cStop(void)
;   {
	.dbline 343
; 	I2C_I2CONSET |= I2C_STOP_BIT;                 // Set the stop bit 
	ldr R0,LIT_I2cStop+0
	ldr R1,[R0,#0]
	orr R1,R1,#16
	str R1,[R0,#0]
	.dbline 344
;   I2cPacketInProgress = FALSE;                  // Flag for stating I2C packet is done
	mov R0,#0
	ldr R1,LIT_I2cStop+4
	strb R0,[R1,#0]
	.dbline 346
; 
;   GPIO_IOCLR = P0_9;                            // Clear P0_9 for debug
	mov R0,#512
	ldr R1,LIT_I2cStop+8
	str R0,[R1,#0]
	.dbline -2
L52:
	mov R15,R14
	.dbline 0 ; func end
LIT_I2cStop:
	DCD -536756224
	DCD _I2cPacketInProgress
	DCD -536707060
	.dbend
	EXPORT _pll_isr
	.dbfunc e pll_isr _pll_isr fV
	AREA	"C$$code", CODE, READONLY
	ALIGN 4
_pll_isr:
	sub R14,R14,#4
	stmfd R13!,{R0,R1,R11,R12,R14}
	mov R11,R13
	.dbline -1
	.dbline 362
;   }
; 
; /*
; |------------------------------------------------------------------------------------------
; |     Function        :   pll_isr
; |     Inputs          :   None
; |     Outputs         :   None
; |     Purpose         :   Once PLL has locked, connect it and use for system clock
; |     Author			    :   Micromint, Inc.
; |------------------------------------------------------------------------------------------
; */
; 
; #pragma interrupt_handler pll_isr
; 
; void pll_isr(void)
;   {
	.dbline 363
;   SCB_PLLCON |= 0x02;                           // Connect the PLL 
	ldr R0,LIT_pll_isr+0
	ldr R1,[R0,#0]
	orr R1,R1,#2
	str R1,[R0,#0]
	.dbline 364
;   SCB_PLLFEED = 0xAA;					   	  	          // Shadow register copy to enable changes
	mov R0,#170
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 365
;   SCB_PLLFEED = 0x55;                           // in PLLCON and PLLCFG
	mov R0,#85
	ldr R1,LIT_pll_isr+4
	str R0,[R1,#0]
	.dbline 366
;   VICIntEnClear = PLL_CLR;                      // Clear PLL interrupt flag
	mov R0,#4096
	ldr R1,LIT_pll_isr+8
	str R0,[R1,#0]
	.dbline 367
;   VICVectAddr = VIC_ACK;                        // Acknowledge Interrupt
	mov R0,#0
	ldr R1,LIT_pll_isr+12
	str R0,[R1,#0]
	.dbline -2
L53:
	ldmfd R13!,{R0,R1,R11,R12,PC}^
	.dbline 0 ; func end
LIT_pll_isr:
	DCD -534790016
	DCD -534790004
	DCD -4076
	DCD -4048
	.dbend
	AREA	"Cudata", NOINIT
_I2cBuffer:
	SPACE 20
	.dbsym s I2cBuffer _I2cBuffer A[20:20]c
	END
